/****************************/
//for 24bit-adc HP20X senosr
/****************************/


//Code:
//const float sea_press = 1013.25;

//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;        
void HP20X_CH1_WriteCmd(uchar uCmd){
        CH1_Start();
        CH1_WriteByte(HP20X_I2C_DEV_ID);
        CH1_WriteByte(uCmd);
        CH1_Stop();
}

//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;        
void HP20X_CH1_WriteCmd_ID2(uchar uCmd){
        CH1_Start();
        CH1_WriteByte(HP20X_I2C_DEV_ID2);
        CH1_WriteByte(uCmd);
        CH1_Stop();
}
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;        

ulong HP20X_CH1_ReadData(void){ 
       
        //ulong TempData;
        CH1_Start();
        CH1_WriteByte(HP20X_I2C_DEV_ID|I2C_DID_RD_MASK);
        
        return HP20X_CH1_ReadData3byte();
        
}   
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ulong HP20X_CH1_ReadData3byte(void){
        uchar Temp;
        ulong TempData;
        Temp=0;
        Temp=CH1_ReadByte();
        CH1_ACK();              
        TempData=Temp;    
        TempData<<=8;      
              
              
        Temp=CH1_ReadByte();
        CH1_ACK();              
        TempData|=Temp;    
        TempData<<=8;  
              
        Temp=CH1_ReadByte();                     
        TempData|=Temp;
        
        if(TempData&0x800000)
        	{TempData|=0xff000000;}
        return TempData;
        
} 



//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//;INPUT:
//;WR2=bReg
//;WR3=bData
void HP20X_CH1_WriteReg(uchar bReg,uchar bData){
        CH1_Start();
        CH1_WriteByte(HP20X_I2C_DEV_ID);
        CH1_WriteByte(bReg|HP20X_WR_REG_MODE);
        CH1_WriteByte(bData);
        CH1_Stop();
        
}

void HP20X_CH1_WriteReg_ID2(uchar bReg,uchar bData){
        CH1_Start();
        CH1_WriteByte(HP20X_I2C_DEV_ID2);
        CH1_WriteByte(bReg|HP20X_WR_REG_MODE);
        CH1_WriteByte(bData);
        CH1_Stop();
        
}
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;     
//;INPUT:
//;WR2=bReg
//;OUTPUT:WR1       
uchar HP20X_CH1_ReadReg(uchar bReg){
        uchar Temp;
        HP20X_CH1_WriteCmd(bReg|HP20X_RD_REG_MODE);
        CH1_Start();
        CH1_WriteByte(HP20X_I2C_DEV_ID|I2C_DID_RD_MASK);
        Temp=CH1_ReadByte();
        CH1_NoAck();
        CH1_Stop();
        return Temp;
        
}        

//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;     
//;INPUT:
//;WR2=bReg
//;OUTPUT:WR1       
uchar HP20X_CH1_ReadReg_ID2(uchar bReg){
        uchar Temp;
        HP20X_CH1_WriteCmd(bReg|HP20X_RD_REG_MODE);
        CH1_Start();
        CH1_WriteByte(HP20X_I2C_DEV_ID2|I2C_DID_RD_MASK);
        Temp=CH1_ReadByte();
        CH1_NoAck();
        CH1_Stop();
        return Temp;
        
}        
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;        
void CH1_ReadTemperature(void){
        uchar Temp;
        uchar Temp0;
 
        HP20X_CH1_WriteCmd(HP20X_WR_CONVERT_CMD|OSR_CFG);	//adc convert
 
        Timer_Delayxms(OSR_ConvertTime);			//difference OSR_CFG will be difference OSR_ConvertTime
        HP20X_CH1_WriteCmd(HP20X_READ_T);
       
        CH1Temperature=HP20X_CH1_ReadData();
        CH1_NoAck();      
        CH1_Stop();
        
        
        AlarmStatus=HP20X_CH1_ReadReg(0x0d); 
        INT_DIR= HP20X_CH1_ReadReg(0x0E); //INT_DIR
        
        
}      
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;        
void CH1_ReadPressure(void){
          HP20X_CH1_WriteCmd(HP20X_WR_CONVERT_CMD|OSR_CFG);
         Timer_Delayxms(OSR_ConvertTime);
        HP20X_CH1_WriteCmd(HP20X_READ_P);
        CH1Pressure=HP20X_CH1_ReadData();
        CH1_NoAck();      
        CH1_Stop();
        AlarmStatus=HP20X_CH1_ReadReg(0x0d);
        INT_DIR= HP20X_CH1_ReadReg(0x0E); //INT_DIR
        
}       
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                      
void CH1_ReadAltitude(void){
        HP20X_CH1_WriteCmd(HP20X_READ_A);
        CH1Altitude=HP20X_CH1_ReadData();
        CH1_NoAck();      
        CH1_Stop();
        AlarmStatus=HP20X_CH1_ReadReg(0x0d);
        INT_DIR= HP20X_CH1_ReadReg(0x0E); //INT_DIR
        
}    
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    
void CH1_ReadPressureAndTemperature(void){

        HP20X_CH1_WriteCmd(HP20X_WR_CONVERT_CMD|OSR_CFG);
        Timer_Delayxms(OSR_ConvertTime*2);
        HP20X_CH1_WriteCmd(HP20X_READ_PT);
        
        CH1Temperature=HP20X_CH1_ReadData();
        CH1_ACK();
        CH1Pressure=HP20X_CH1_ReadData3byte();
        CH1_NoAck();      
        CH1_Stop(); 
}

//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                                    
void CH1_ReadAltitudeAndTemperature(void){

       HP20X_CH1_WriteCmd(HP20X_WR_CONVERT_CMD|OSR_CFG);
         Timer_Delayxms(OSR_ConvertTime*2);
        HP20X_CH1_WriteCmd(HP20X_READ_AT);
        
        CH1Temperature=HP20X_CH1_ReadData();
        CH1_ACK();
        CH1Altitude=HP20X_CH1_ReadData3byte();
        CH1_NoAck();      
        CH1_Stop();  
                   
}
         
