#include "pic.h"
#include <stdio.h>
#include <htc.h>
//#include <math.h>
#include "DefineRam.h"
#include "DefineConst_IO.h"
#include "function_arg.h"
#include "I2C.C"
#include "HP20xv101.c"

//	__CONFIG(0xFCD5);
//__CONFIG(WDTDIS&HS&UNPROTECT&MCLREN&PWRTDIS);
	__CONFIG(FOSC_ECH&FOSC_HS&WDTE_OFF&PWRTE_OFF&MCLRE_ON&CP_OFF&BOREN_OFF&CLKOUTEN_OFF);


/*******************************************************************************
FuncName:	CPUIO_Init
Input:
Output:
********************************************************************************/
void CPUIO_Init(void)
{
	//-----------------------------------------------clr ram
	#asm
		movlw	0x20			;	//address start 0x20
    clr_loop:
		movwf _FSR0
		clrf _INDF0
		incf _FSR0
		movf _FSR0,w
		btfss _FSR0,6
		goto clr_loop
	#endasm
	
	//-----------------------------------------------
	CLRWDT();
	INTCON = 0x00;	                //dis all interrupt
	//WDTCON = 0X09;
	WDTCON=0;
	OSCCON = 0X70;	                //INROSC=8MHZ,but had select HS by FOSC[2:0}
//	OSCTUNE = 0x00; 
        
	PCON = 0x03;			//disable BOR,POR
       // OPTION=0;
        
        
	
	ADCON1 = 0x00;

//	IOCB = 0x00;            //Interrupt-on-change disabled
	PIR1 = 0x00;
//	PIR2 = 0x00;
	PIE1 = 0x00;
	
	
	ADCON0 = 0x00;          //Disabel ADC Function          RA
//	CMCON0=0X07;            //set RA IS DIGIT I/O	
	ANSELA=0X00;
	ANSELB=0X00;
	ANSELC=0X00;
	ANSELD=0X00;
	ANSELE=0X00;
	
//	IOCB=0;                 //DISABLE RB INTERRUPT          RB
//	RBPU=0;                 //DISABLE ALL PULL-UP
//	CCP1CON=0X0C;           //PWM MODE,AND 50%
	OPTION_REG=0;
	
	WPUB=0XFf;
	
	CCP2CON=0X00;           //OFF PWM                       RD
	
	

//RFM,CH1,CH2,CH3 I/O
	//RFM_INT1_I;
	//RFM_SCL_O;
	//RFM_SDA_O;
	CH1_INT0_I;
	CH1_INT1_I;
	CH1_SCL_O;
	CH1_SDA_O;
	CH1_CSB_O;
	
	
	//OUTPUT
	RFM_SCL=1;
	RFM_SDA=1;
	CH1_SCL=1;
	CH1_SDA=1;
	CH1_CSB=1;


	
}
/*********************************************************
Function: Timer_Delayxms(uchar xms)    @10MHz Tcyc=0.4us
*********************************************************/
void Timer_Delayxms(uint n)		//Tmin=1ms
{
	uchar i;
	while(n--)
	{
		for(i = 0; i<210; i++)		//11x0.4=4.4us
		{
			asm("nop");asm("nop");asm("nop"); //1.2us
		}
	}
}


//===================================================================
static void interrupt isr_vect(void)
{
//        uchar Temp;
       // uchar i;
        if(IOCIF==1);
        {
        	IOCIF=0;
        	
        }
	if(TMR1IF ==1)//62.5MS
	{
	        TMR1IF=0;
		TMR1H=(65536-62500)/256;
                TMR1L=(65536-62500)%256;
                Time62r5ms++;
                
                
                if(CYC_SAMPLE_CNT==2){
			if(SampleCYC!=0)
				SampleCYC--;
			}	
	        
                
                
                if(Time62r5ms==8)
                 {	//0.5s
                        Time62r5ms=0; 
                        F_HalfSec=1;
                   
           
                      	}	
                  }
                      	

}
/************************************************************************************/
/
/************************************************************************************/
void InitRam(void){
        uchar i;
        
        RxIndex=0;
        F_Sync=0;
        for(i=0;i<20;i++){
                Input[i]=0;
                
        }
        
        OSR_VALUE=1024;
        OSR_CFG=HP20X_CONVERT_OSR1024;
        OSR_ConvertTime=25;//	18MS
        AVGCNT=32;
        
        KeyName=None_Key;
        F_ALT_REL_ABS=0;
        F_Unit_OnOff=0;
        CH_NO=0;
        Mode=0;
        AUTO_TURN_OFF_CNT=0;
        CYC_SAMPLE_CNT=0;	//1.5seconds
        SampleCYC=0;
        F_USB_ONOFF=0;		////usb off
        AUTO_TURN_OFF_CNT=10;
        AUTO_TURNOFF_MIN=AUTO_TURN_OFF_CNT;	
        AUTO_TURNOFF_SEC=0;	//120
        F_Mean_out=1;
        
}



/************************************************************************************/
void main(void)
{
     //   uchar i;
     //   uchar SYS;
        
        CPUIO_Init ();

        INTCON=0;	// purpose of disabling the interrupts.
        
        
        T1CON=0X10;//1:2,FOSC/4
      
        TMR1H=(65536-62500)/256;             //8M/4=2M,F=2M/8=1/4M,T=(0XFFFF-TMR1H TMR1L+1)*1/F=(0XFFFF-TMR1H TMR1L+1)*4
        TMR1L=(65536-62500)%256;  	     //10M/4=2.5M. 2.5/2=1.25MHZ,  T=(0XFFFF-CNT)X0.8US
        GIE=1;
        PEIE=1;
        TMR1IE=1;
        TMR1ON=1;
        RCIE=0;//1;	//disable RX int
        init_comms();
     	InitRam();
     	
     	
        

    	
       HP20X_CH1_WriteCmd(HP20X_SOFT_RST);
     
       Timer_Delayxms(100); 
                     
 
     	CH1_READY=0X0;
    
    	CH1_READY=HP20X_CH1_ReadReg(0x0f);

     	
	if(CH1_READY==0X80|CH1_READY==0X81)
	 {   	

      	CH1_ReadPressureAndTemperature();				    
	CH1_ReadAltitude();
      	CH1AvgPressure=CH1Pressure;
      	CH1AvgAltitude=CH1Altitude;
	
    
	for(uchar i=0;i<32;i++){
		CH1AltitudeBuf[i]=CH1Altitude;
		}
	for(uchar i=0;i<32;i++){
		CH1PressureBuf[i]=CH1Pressure;
		}
	}
      	
      


				
	
//////////////////////////////////////////////////////////////

//.................main programe..............................

//////////////////////////////////////////////////////////////
    while(1)		//main looping
  { 
  
     if(SampleCYC==0&Mode==0)
     {
     	if(CYC_SAMPLE_CNT==1){
     		SampleCYC==0;	//this case,do not use any cycle timer. as fast as the OSR_ConvertTime and "main" running time.
		}
        else if(CYC_SAMPLE_CNT==2){
			SampleCYC=3;			//200MS
		}
								
		else {
           SampleCYC=CYC_SAMPLE_CNT/10;
             }	//reload
    	
    	
    	
		if(CH1_READY==0X80|CH1_READY==0X81)
			{
			if(F_Scroll==1|CH_NO==1)	
			 {		
			CH1_ReadPressureAndTemperature();				    
			CH1_ReadAltitude();
			Save_CH1AltitudeBuf();
			Save_CH1PressureBuf();	
			if(F_Mean_out==1)
			{CH1_ALT_REL=CH1AvgAltitude-CH1_ALT_REL_REF;}
			else{CH1_ALT_REL=CH1Altitude-CH1_ALT_REL_REF;}
			
											
				if(F_USB_ONOFF&F_Mean_out==0){
				output_chx(1);
				putch(9);
				Hex_to_Dec(CH1Pressure);
				output_p();
       	 			putch(9);
       	 			Hex_to_Dec(CH1Altitude);
				output_a();
				putch(9);
				Hex_to_Dec(CH1Temperature);
				output_t();
        			putch(0x0D);
        			putch(0x0A);}
			 }
			
		}
/*		if(CH2_READY==0X80)
		{
			if(F_Scroll==1|CH_NO==2)	
			{
			CH2_ReadPressureAndTemperature();				    
			CH2_ReadAltitude();
			Save_CH2AltitudeBuf();
			Save_CH2PressureBuf();	
			if(F_Mean_out==1)
			{CH2_ALT_REL=CH2AvgAltitude-CH2_ALT_REL_REF;}
			else{CH2_ALT_REL=CH2Altitude-CH2_ALT_REL_REF;}
			
			
				if(F_USB_ONOFF&F_Mean_out==0){
				//F_Mean_out=1;
				output_chx(2);
				putch(9);
				Hex_to_Dec(CH2Pressure);
				output_p();
       	 			putch(9);
       	 			Hex_to_Dec(CH2Altitude);
				output_a();
				putch(9);
				Hex_to_Dec(CH2Temperature);
				output_t();
        			putch(0x0D);
     				putch(0x0A);}
     			}
        		KEY_SCAN();
			//if(F_KeyRelease==1)
			//break;
		
		}
		if(CH3_READY==0X80)
		{
			if(F_Scroll==1|CH_NO==3)
			{	
			CH3_ReadPressureAndTemperature();				    
			CH3_ReadAltitude();
			Save_CH3AltitudeBuf();
			Save_CH3PressureBuf();
			if(F_Mean_out==1)
			{CH3_ALT_REL=CH3AvgAltitude-CH3_ALT_REL_REF;}
			else {CH3_ALT_REL=CH3Altitude-CH3_ALT_REL_REF;}
			
				if(F_USB_ONOFF&F_Mean_out==0){
				output_chx(3);
				putch(9);
				Hex_to_Dec(CH3Pressure);
				output_p();
       	 			putch(9);
       	 			Hex_to_Dec(CH3Altitude);
				output_a();
				putch(9);
				Hex_to_Dec(CH3Temperature);
				output_t();
        			putch(0x0D);
        			putch(0x0A);}
        		}	
			KEY_SCAN();
			//if(F_KeyRelease==1)
			//break;
		}
	   //	SampleCNT--;
       	   // }
	
	 
	     
	    
        	 
        	 
	  }
	  

	
	  
     }	
*/
//....................................	
	




     
   
}	
//============================================================
/*************************************************************/	
void Save_CH1AltitudeBuf(void)
{
	uchar i;
    uchar j=1;
	//ulong highvalue=0;
    CH1AvgAltitude=0;
	for(i=0;i<32;i++)
	{
	 CH1AltitudeBuf[i]=CH1AltitudeBuf[j];
		j++;	
	}
	CH1AltitudeBuf[31]=CH1Altitude;
	for(i=0;i<32;i++)
	{
	 
	CH1AvgAltitude+=CH1AltitudeBuf[i];
	}
	CH1AvgAltitude=CH1AvgAltitude/32;
	
	
	
}


/*************************************************************/	
void Save_CH1PressureBuf(void)
{
	uchar i;
	uchar j=1;
    	CH1AvgPressure=0;
	for(i=0;i<32;i++)
	{
	 CH1PressureBuf[i]=CH1PressureBuf[j];
		j++;	
	}
	CH1PressureBuf[31]=CH1Pressure;
	for(i=0;i<32;i++)
	{
	 
	CH1AvgPressure+=CH1PressureBuf[i];
	}
	CH1AvgPressure=CH1AvgPressure/32;
	
	
	
}
//============================================================
/*************************************************************/	
void Save_CH2AltitudeBuf(void)
{
	uchar i;
	uchar j=1;
	//ulong highvalue=0;
    CH2AvgAltitude=0;
	for(i=0;i<32;i++)
	{
	 CH2AltitudeBuf[i]=CH2AltitudeBuf[j];
		j++;	
	}
	CH2AltitudeBuf[31]=CH2Altitude;
	for(i=0;i<32;i++)
	{
	 
	CH2AvgAltitude+=CH2AltitudeBuf[i];
	}
	CH2AvgAltitude=CH2AvgAltitude/32;//32;
	
	
	
}


/*************************************************************/	
void Save_CH2PressureBuf(void)
{
	uchar i,j=1;
    	CH2AvgPressure=0;
	for(i=0;i<32;i++)
	{
	 CH2PressureBuf[i]=CH2PressureBuf[j];
		j++;	
	}
	CH2PressureBuf[31]=CH2Pressure;
	for(i=0;i<32;i++)
	{
	 
	CH2AvgPressure+=CH2PressureBuf[i];
	}
	CH2AvgPressure=CH2AvgPressure/32;
	
	
	
}
//============================================================

//============================================================
/*************************************************************/	
void Save_CH3AltitudeBuf(void)
{
	uchar i,j=1;
	//ulong highvalue=0;
    	CH3AvgAltitude=0;
	for(i=0;i<32;i++)
	{
	CH3AltitudeBuf[i]=CH3AltitudeBuf[j];
		j++;	
	}
	CH3AltitudeBuf[31]=CH3Altitude;
	for(i=0;i<32;i++)
	{
	 
	CH3AvgAltitude+=CH3AltitudeBuf[i];
	}
	CH3AvgAltitude=CH3AvgAltitude/32;
	
}


/*************************************************************/	
void Save_CH3PressureBuf(void)
{
	uchar i,j=1;
    	CH3AvgPressure=0;
	for(i=0;i<32;i++)
	{
	 CH3PressureBuf[i]=CH3PressureBuf[j];
		j++;	
	}
	CH3PressureBuf[31]=CH3Pressure;
	for(i=0;i<32;i++)
	{
	 
	CH3AvgPressure+=CH3PressureBuf[i];
	}
	CH3AvgPressure=CH3AvgPressure/32;
	
	
	
}
	
//============================================================ 
/*void TimeAdd(void)
{
        if(F_HalfSec)
        	{
                F_HalfSec=0;
                HalfSec++;//0.5s
                if(!(HalfSec&0x01))
                {//1s
                        
                }
                
                 
        }        
}
*/
